program CosmicBattle;

uses
  OpenGL,
  Windows,
  eXgine,
  Consts,
  GUI in 'GUI.pas',
  level in 'level.pas',
  MyInterface in 'MyInterface.pas',
  Main in 'Main.pas',
  Enemy in 'Enemy.pas',
  Player in 'Player.pas';

{$R LostGifts.res}

procedure Init;
begin
  wnd.Mode(false, ScreenStartX, ScreenStartY, ScreenW, ScreenH, 32, 75);
  MainInit;
end;

procedure Free;
begin
  MainFree;
end;

procedure Update;
begin
  MainProcessBegin;
  MainProcess;
  MainProcessEnd;
  //if inp.Down(Key_Escape) then MainExit;
end;

procedure Render;
begin
  ogl.Clear(True,True);
//  
  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  MainDraw;
  glColor3f(1, 1, 1);
  ogl.TextOut(0, 8, 16, PChar('FPS: ' + IntToStr(ogl.FPS)));
end;

begin
  ScreenStartX:= (GetSystemMetrics(SM_CXSCREEN) div 2) - (ScreenW div 2);
  ScreenStartY:= (GetSystemMetrics(SM_CYSCREEN) div 2) - (ScreenH div 2);
  wnd.Create('Interface');
  eX.SetProc(PROC_INIT,@Init);
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);
  eX.SetProc(PROC_FREE, @Free);
  inp.MCapture(false);
  ShowCursor(false);
  eX.MainLoop(50);
end.
