unit sNail;
{--------------------------SNAIL ENGINE HEADER--------------------------------------

 Autor: Hex[man] (Khorobrykh Kirill) 
 E-Mail:hex.man@mail.ru
 
 Create Date: 03.03.2006
 Last Renovation: 16.12.2009

 Version: 0.9.0.4
------------------------------------------------------------------------------------}
interface
uses Windows;
//-------------------------------------Road map-------------------------------------

{

    + Added
    - Removed
    * Modify
    ! Fixed

  v0.9.0.4 [16.12.2009] -------------
  +   inp_Reset,  

  v0.9.0.3 [08.12.2009] -------------
  *  tex_Load   ,    
  +   

  v0.8.9.7 [05.03.2009] -------------
  +   gl_RenderClip,    
  +    	
	
  v0.8.9.4 [17.12.2008] -------------
  +  DDS 
  *   JPG 
  +  
	
  v0.8.9.2 [24.11.2008] -------------
  +       HTTP,FTP   .  inet_
  +  inp_MouseDblClick,      
  -   
  	
  v0.8.8.5 [07.09.2008] -------------
  !    ini_***   
  + pack_Reset -       
  !  ""    

  v0.8.8 [20.07.2008] -------------
  + AntiAliasing
  !     snail_GetTime
  !   stream_Play

  v0.8.7 [16.07.2008] -------------
  +   ,   :)
  +   gl_SetColor
  +      
  -  ,    ,     

  v0.8.6 [25.06.2008] -------------
  +   pack_LoadInMem,      
  *   pack_ExtractFile
  +   
    
  v0.8.4 [29.05.2008] -------------
  -     gl_Teapot
  +  Gif  [1 ]
  +   joy_GetName,   
  +        , . snd_SetVolumeAll 
  + 
   
  v0.8.1 [22.05.2008] -------------
  +        OpenGL
  +   inp_SetMousePos,     
  *   inp_MousePos  inp_GetMousePos
  !   inp_MouseWheel 
  *     []
  *   log_AddStr     c   FileName
  -      ini  ini_WriteValue  ini_ReadValue
  +  6       INI  [  ini]
  -     MessageBox',  -   
  !   
  *   
  -------------
  [03.03.2006 - 22.05.2008] - Roadmap is empty

}
//------------------------------------- End Road map---------------------------------
const
  SNAIL_DLL = 'sNail.dll';
  CONFIG_INI = 'Config.ini';

  // Procedures ...
  PROC_PRELOAD = $00;
  PROC_INIT = $01;
  PROC_UPDATE = $02;
  PROC_RENDER = $03;
  PROC_FREE = $04;
  // Texture filter type ...
  FILTER_NONE = $00;
  FILTER_BILINEAR = $01;
  FILTER_TRILINEAR = $02;
  FILTER_ANISOTROPY = $03;
  // Mouse Buttons...
  MOUSE_BTN_LEFT = $01;
  MOUSE_BTN_RIGHT = $02;
  MOUSE_BTN_MIDDLE = $03;
  MOUSE_BTN_4 = $04;
  MOUSE_BTN_5 = $05;
  MOUSE_BTN_6 = $06;
  // Console command types ...
  CMD_PROC = $00;
  CMD_INT = $01;
  CMD_FLOAT = $02;
  CMD_STRING = $03;
  // Blend ...
  BLEND_NONE = $00;
  BLEND_SUB = $01;
  BLEND_ADD = $02;	

  type
    sRect = record
      x, y, w, h: smallint;
    end;
  // --- Application functions ---
  procedure snail_Run(Width,Height:word;BPP,Freq,Samples:byte;Fullscreen,VSync,LogFile:boolean);stdcall;external SNAIL_DLL;
  procedure snail_SetTimer(Interval:word);stdcall;external SNAIL_DLL;
  function snail_GetTimer:word;stdcall;external SNAIL_DLL;
  function snail_GetHandle:HWND;stdcall;external SNAIL_DLL;
  function snail_GetCPUTick:DWORD;stdcall;external SNAIL_DLL;
  procedure snail_RegProc(ID:byte;Addr:pointer);stdcall;external SNAIL_DLL;
  procedure snail_SetName(const Name:PChar);stdcall;external SNAIL_DLL;
  procedure snail_Stop;stdcall;external SNAIL_DLL;
  function snail_GetDate:PChar;stdcall;external SNAIL_DLL;
  function snail_GetTime:PChar;stdcall;external SNAIL_DLL;
  function snail_Version:PChar;stdcall;external SNAIL_DLL;
  // --- INI files ---
  procedure log_AddStr(const FileName,Text:PChar);stdcall;external SNAIL_DLL;
  procedure log_Rewrite(const FileName:PChar);stdcall;external SNAIL_DLL;
  procedure ini_WriteStr(FileName,Section,Key,Value:PChar);stdcall;external SNAIL_DLL;
  function ini_ReadStr(FileName,Section,Key:PChar):PChar;stdcall;external SNAIL_DLL;
  procedure ini_WriteInt(FileName,Section,Key:PChar; Value:integer);stdcall;external SNAIL_DLL;
  function ini_ReadInt(FileName,Section,Key:PChar):integer;stdcall;external SNAIL_DLL;
  procedure ini_WriteBool(FileName,Section,Key:PChar;Value:boolean);stdcall;external SNAIL_DLL;
  function ini_ReadBool(FileName,Section,Key:PChar):boolean;stdcall;external SNAIL_DLL;
  // --- Input ---
  function inp_KeyPress(Key:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_KeyUp(Key:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_GetKey:Char;stdcall;external SNAIL_DLL;
  procedure inp_BeginReadKeys(const default:PChar);stdcall; external SNAIL_DLL;
  procedure inp_EndReadKeys;stdcall;external SNAIL_DLL;
  function inp_GetReadKeys:PChar;stdcall;external SNAIL_DLL;
  function inp_PressAnyBtn:boolean;stdcall;external SNAIL_DLL;
  function inp_GetMousePos:TPoint;stdcall;external SNAIL_DLL;
  procedure inp_SetMousePos(x,y:integer);stdcall;external SNAIL_DLL;
  function inp_MousePress(Button:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_MouseUp(Button:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_MouseClick(Button:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_MouseDblClick(Button:byte):boolean;stdcall;external SNAIL_DLL;
  function inp_GetMouseBtn:byte;stdcall;external SNAIL_DLL;
  function inp_MouseWheel:smallint;stdcall;external SNAIL_DLL;
  function inp_MouseMove:boolean;stdcall;external SNAIL_DLL;
  procedure inp_Reset;stdcall;external SNAIL_DLL;
  // --- System and 3D fonts ---
  function fnt_Init(FontName:PChar;Width,Height:byte):integer;stdcall;external SNAIL_DLL;
  procedure fnt_Render(ID:integer;x,y:Single;Text:PChar);stdcall;external SNAIL_DLL;
  procedure fnt_Free(ID:integer);stdcall;external SNAIL_DLL;
  function fnt_Init3D(FontName:PChar):integer;stdcall;external SNAIL_DLL;
  procedure fnt_Render3D(ID:integer;Text:PChar);stdcall;external SNAIL_DLL;
  // --- OpenGL functions ---
  function gl_GetFPS:word;stdcall;external SNAIL_DLL;
  function gl_GetResX:word;stdcall;external SNAIL_DLL;
  function gl_GetResY:word;stdcall;external SNAIL_DLL;
  procedure gl_SetBlend(ID:byte);stdcall;external SNAIL_DLL;
  procedure gl_SetColor(Color:integer;Alpha:byte = 255);stdcall;external SNAIL_DLL;
  procedure gl_LightDefault(const ID:integer);stdcall;external SNAIL_DLL;
  procedure gl_LightPos(const ID:integer;x,y,z:single);stdcall;external SNAIL_DLL;
  procedure gl_LightColor(const ID:integer;R,G,B:single);stdcall;external SNAIL_DLL;
  procedure gl_SetOrtho;stdcall;external SNAIL_DLL;
  procedure gl_SetOrtho3D;stdcall;external SNAIL_DLL;
  procedure gl_SetPerspective(angle,zNear,zFar:single);stdcall;external SNAIL_DLL;
  procedure gl_Position2D(x,y,z:single);stdcall;external SNAIL_DLL;
  procedure gl_TexEnable(const Texture:cardinal);stdcall;external SNAIL_DLL;
  procedure gl_TexDisable;stdcall;external SNAIL_DLL;
  procedure gl_RenderTex(x,y:single;Width,Height:word; Angle:integer);stdcall;external SNAIL_DLL;
  procedure gl_RenderSprite(x,y:single;Width,Height,XFrames,YFrames,FrameNum:word;Angle:integer);stdcall;external SNAIL_DLL;
  procedure gl_RenderClip(Texture:cardinal;x,y:single; Width,Height:word; Clip:sRect; Angle:integer);stdcall;external SNAIL_DLL;
  procedure gl_ClearScreen(Color:boolean = true; Depth:boolean = false; Stencil:boolean = false);stdcall;stdcall;external SNAIL_DLL;
  // --- Archives ---
  function pack_ExtractFiles(const PackName:PChar;FileNames:array of const;Path:PChar):boolean;stdcall;external SNAIL_DLL;
  procedure pack_SetPassword(const Password:PChar);stdcall;external SNAIL_DLL;
  function pack_LoadInMem(const PackName,FileName:PChar; var Size:cardinal):Pointer;stdcall;external SNAIL_DLL;
  function pack_GetNames(const PackName:PChar;Separator:Char):PChar;stdcall;external SNAIL_DLL;
  procedure pack_Reset;stdcall;external SNAIL_DLL;
  // --- Textures --- (BMP,JPG,TGA,PNG,GIF,DDS)
  function tex_CreateEmpty(Width,Height:word;Filter:integer):cardinal;stdcall;external SNAIL_DLL;
  function tex_Load(const PackName,FileName:PChar;MipMap:boolean):cardinal;stdcall;external SNAIL_DLL;
  //  function tex_LoadInMem(PackName,FileName:Pchar; var Width,Height:word; var Data:pointer):boolean;stdcall;external SNAIL_DLL;
  procedure tex_Free(var Texture:cardinal);stdcall;external SNAIL_DLL;
  procedure tex_Params(FilterType:byte; Compress:boolean = false);stdcall;external SNAIL_DLL;
  function tex_GetSize(const Texture:cardinal):TPoint;stdcall;external SNAIL_DLL;
  // --- Direct Sound ---
  function snd_Init:boolean;stdcall;external SNAIL_DLL;
  procedure snd_Play(ID:integer);stdcall;external SNAIL_DLL;
  procedure snd_Stop(ID:integer);stdcall;external SNAIL_DLL;
  procedure snd_StopAll;stdcall;external SNAIL_DLL;
  procedure snd_SetVolume(ID:integer; Volume:byte);stdcall;external SNAIL_DLL;
  procedure snd_SetVolumeAll(Volume:byte);stdcall;external SNAIL_DLL;
  procedure snd_SetFreq(const ID:integer;Value:integer);stdcall;external SNAIL_DLL;
  procedure snd_SetPosition(ID:integer; X,Y,Z:single);stdcall;external SNAIL_DLL;
  procedure snd_GetPosition(ID:integer; var X,Y,Z:single);stdcall;external SNAIL_DLL;
  procedure snd_Free(ID:integer);stdcall;external SNAIL_DLL;
  function snd_Load(const PackName,FileName:PChar):integer; stdcall;external SNAIL_DLL;
  function snd_isPlay(ID:integer):boolean;stdcall;external SNAIL_DLL;
  // --- Stream music ---
  procedure stream_Play(const FileName:PChar; Loop:boolean = true);stdcall;external SNAIL_DLL;
  procedure stream_Stop;stdcall;external SNAIL_DLL;
  // --- Console ---
  procedure cnsl_Create(Font:cardinal;Color,FontColor:integer);stdcall;external SNAIL_DLL;
  procedure cnsl_RegCmd(const Name:PChar;Addr:pointer;CmdType:byte);stdcall;external SNAIL_DLL;
  function cnsl_ExecFile(const FileName:PChar):boolean;stdcall;external SNAIL_DLL;
  function  cnsl_LastCmd:PChar;stdcall;external SNAIL_DLL;
  procedure cnsl_AddStr(const Text:PChar; Color:integer  = 0);stdcall;external SNAIL_DLL;
  function  cnsl_IsActive:boolean;stdcall;external SNAIL_DLL;
  procedure cnsl_SetLineColor(Color:integer);stdcall;external SNAIL_DLL;
  procedure cnsl_Clear;stdcall;external SNAIL_DLL;
  procedure cnsl_Update;stdcall;external SNAIL_DLL;
  procedure cnsl_Render;stdcall;external SNAIL_DLL;
  // --- Download files ---
  function inet_Connect:boolean;stdcall;external SNAIL_DLL;
  function inet_IsFileExists(URL:PChar):boolean;stdcall;external SNAIL_DLL;
  function inet_Download(URL,DestFile:PChar):boolean;stdcall;external SNAIL_DLL;
  procedure inet_Disconnect;stdcall;external SNAIL_DLL;
  // --- Conversion of types ---
  function Int2Str(Value:integer):string;
  function Str2Int(S:string):integer;
  function Float2Str(Value:single):string;
  function Str2Float(S:string):single;
  // --- Other ---

  function makeRect(x, y, Width, Height: smallint): sRect;
  function moveRect(x, y: integer; Rect: sRect): sRect;

  function fileExist(const filename:string):boolean;

implementation

  function Int2Str(Value:integer):string;
  begin
    Str(Value,Result);
  end;

  function Str2Int(S:string):integer;
  var
    err:integer;
  begin
    Val(S,Result,err);
    if err <> 0 then result:=0;
  end;
  
  function Float2Str(Value:single):string;
  begin
    Str(Value:0:2,Result);
  end;

  function Str2Float(S:string):single;
  var
    err:integer;
  begin
    Val(S,Result,err);
    if err <> 0 then Result:=0.0;
  end;

  function makeRect(x, y, Width, Height: smallint):sRect;
  begin
    Result.x := x;
    Result.y := y;
    Result.w := Width;
    Result.h := Height;
  end;

  function moveRect(x, y: integer; Rect: sRect): sRect;
  begin
    Result.x := Rect.x + x;
    Result.y := Rect.y + y;
    Result.w := Rect.w + x;
    Result.h := Rect.h + y;
  end;

  function fileExist(const filename:string):boolean;
  var
    h: THandle;
    f: TWin32FindData;
  begin
    h := FindFirstFile(PChar(filename), f);
    if h <> INVALID_HANDLE_VALUE then
    begin
      windows.FindClose(h);
      Result:=true;
    end else
	  Result:=false;
 end;
  
begin

end.