unit uBB;

interface

type
  cpBB = record
    l, b, r, t: single;
  end;

  function cpBBNew(const l, b, r, t: single): cpBB;
  function cpBBintersects(const a, b: cpBB): boolean;
  function cpBBinBB(const a, b: cpBB):boolean;
  
implementation

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function cpBBNew(const l, b, r, t: single): cpBB;
begin
	result.l:= l;
  result.b:= b;
  result.r:= r;
  result.t:= t;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

function cpBBintersects(const a, b: cpBB): boolean;
begin
  result := (a.l <= b.r) and (b.l <= a.r) and (a.b <= b.t) and (b.b <= a.t);
end;


function cpBBinBB(const a, b: cpBB): boolean;

begin

  Result := (a.l + a.r >= b.l) and (a.l <= b.l + b.r) and
            (a.t + a.b >= b.t) and (a.t <= b.t + b.b);
end;

end.
